"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const account_1 = __importDefault(require("./account"));
const event_1 = __importDefault(require("./event"));
const execution_1 = __importDefault(require("./execution"));
const instance_1 = __importDefault(require("./instance"));
const ownership_1 = __importDefault(require("./ownership"));
const process_1 = __importDefault(require("./process"));
const service_1 = __importDefault(require("./service"));
const runner_1 = __importDefault(require("./runner"));
class API {
    constructor(endpoint) {
        this.account = new account_1.default(endpoint);
        this.event = new event_1.default(endpoint);
        this.execution = new execution_1.default(endpoint);
        this.instance = new instance_1.default(endpoint);
        this.ownership = new ownership_1.default(endpoint);
        this.process = new process_1.default(endpoint);
        this.service = new service_1.default(endpoint);
        this.runner = new runner_1.default(endpoint);
    }
}
exports.default = API;
(module).exports = API;
