import * as ServiceType from './typedef/service';
export declare type IService = ServiceType.mesg.types.IService;
export declare type ServiceGetInputs = ServiceType.mesg.api.IGetServiceRequest;
export declare type ServiceGetOutputs = Promise<IService>;
export declare type ServiceHashInputs = ServiceType.mesg.api.ICreateServiceRequest;
export declare type ServiceHashOutputs = Promise<ServiceType.mesg.api.IHashServiceResponse>;
export declare type ServiceExistsInputs = ServiceType.mesg.api.IExistsServiceRequest;
export declare type ServiceExistsOutputs = Promise<ServiceType.mesg.api.IExistsServiceResponse>;
export declare type ServiceListInputs = ServiceType.mesg.api.IListServiceRequest;
export declare type ServiceListOutputs = Promise<ServiceType.mesg.api.IListServiceResponse>;
export declare type ServiceCreateInputs = ServiceType.mesg.api.ICreateServiceRequest;
export declare type ServiceCreateOutputs = Promise<ServiceType.mesg.api.ICreateServiceResponse>;
export default class Service {
    private _client;
    constructor(endpoint: string);
    create(request: ServiceCreateInputs): ServiceCreateOutputs;
    get(request: ServiceGetInputs): ServiceGetOutputs;
    exists(request: ServiceExistsInputs): ServiceExistsOutputs;
    hash(request: ServiceHashInputs): ServiceHashOutputs;
    list(request: ServiceListInputs): ServiceListOutputs;
}
